<template>
  <v-menu v-model="isOpen" offset-y :close-on-content-click="false" max-width="250px">
    <template v-slot:activator="{ on, attrs }">
      <v-btn
        class="mr-2"
        outlined
        color="accent"
        v-bind="attrs"
        small
        v-on="on"
      >
        <span class="text-capitalize">
          {{ label }}
        </span>
        <v-icon right>
          {{ mdiChevronDown }}
        </v-icon>
      </v-btn>
    </template>
    <v-card>
      <v-row justify="space-around" class="py-2" no-gutters>
        <v-col cols="5">
          <v-text-field
            :value="minFilter"
            dense
            hide-details
            min="100"
            type="number"
            single-line
            outlined
            label="Min"
            @focus="isMinSel = true"
            @change="changeMin"
          />
        </v-col>
        <v-col cols="5">
          <v-text-field
            ref="maxElement"
            :value="maxFilter"
            dense
            hide-details
            max="9999"
            type="number"
            single-line
            outlined
            label="Max"
            @focus="isMinSel = false"
            @change="changeMax"
          />
        </v-col>
        <v-col cols="12" class="pa-0 pt-2">
          <v-list class="pa-0" dense>
            <v-list-item-group :value="filters" color="accent" @change="$event => isMinSel ? changeMin($event) : changeMax($event)">
              <v-list-item v-for="(option, idx) in minMaxOptions" :key="idx" :class="{ 'justify-end': !isMinSel }" :value="option.value">
                {{ option.text }}
              </v-list-item>
            </v-list-item-group>
          </v-list>
        </v-col>
      </v-row>
    </v-card>
  </v-menu>
</template>

<script lang="ts">
import { mdiChevronDown } from '@mdi/js'
import { defineComponent, ref, watch, computed } from '@vue/composition-api'
import { useQuery } from '../hooks'
import { InternalFilters } from '../utils/query'

export default defineComponent({
  name: 'FilterRange',
  props: {
    name: {
      type: String,
      required: true
    },
    options: {
      type: Object,
      required: true
    },
    label: {
      type: String,
      required: true
    }
  },
  setup (props, context) {
    const isMinSel = ref(true)
    const maxElement = ref<Vue>(null)
    const isOpen = ref(false)
    const { filters: beforeFilters, setFilter } = useQuery(context)
    watch(isOpen, () => { isMinSel.value = true })
    const minName = 'min' + props.name as keyof InternalFilters
    const maxName = 'max' + props.name as keyof InternalFilters
    const filters = ref(beforeFilters.value[minName])
    watch(isMinSel, () => {
      filters.value = beforeFilters.value[isMinSel.value ? minName : maxName]
    })

    const changeMin = ($event: string) => {
      setFilter(minName, +$event || undefined)
      isMinSel.value = false
    }
    const changeMax = ($event: string) => {
      setFilter(maxName, +$event || undefined)
      isOpen.value = false
    }
    const minOpts = [{ value: 0, text: 'No min' }, ...props.options.min]
    const maxOpts = [...props.options.max, { value: 0, text: 'No max' }]
    return {
      isMinSel,
      filters,
      changeMax,
      maxElement,
      changeMin,
      minFilter: computed(() => beforeFilters.value[minName]),
      maxFilter: computed(() => beforeFilters.value[maxName]),
      isOpen,
      setFilter,
      minName,
      maxName,
      mdiChevronDown,
      minMaxOptions: computed(() => isMinSel.value ? minOpts : maxOpts)
    }
  }
})
</script>
